<?
/*
	Description: Creates a directory-structured path (mod_structure ?)
	Description: Creates a directory-structured menu

		structure_delimiter

		menu_updated_format
		menu_delimiter
		menu_end_delimiter
		menu_expand_all
		hidden_paths
*/

	/* Configuration variables */
    if (empty($config['menu_expand_all']))
		$config['menu_expand_all']=false;

	if (empty($config['structure_delimiter']))
		$config['structure_delimiter']="&gt;&nbsp;";

    if (empty($config['menu_delimiter']))
		$config['menu_delimiter']="&middot;&nbsp;";

    if (empty($config['menu_end_delimiter']))
	$config['menu_end_delimiter']="&middot;&nbsp;";

	/* Reading titles */
	_setRelDirname();
	$temp=explode('/',$ENV['RELDIRNAME']);
	$p="";
	$fp=$config['path'];
	for($i=0;$i<count($temp);$i++) {
		if ($temp[$i]!='') {
			if ($p!='/') $p.='/'.$temp[$i];
			$fp="$config[path]$p";
		}
		_setTitle("$ENV[DOCUMENT_ROOT]$fp/","$fp/");
	}
	if (is_readable("$ENV[DOCUMENT_ROOT]$ENV[REQUEST_NAME]") and 
		(empty($title[$ENV['REQUEST_NAME']]))) 
		_setTitle("$ENV[DOCUMENT_ROOT]$ENV[REQUEST_NAME]",$ENV['REQUEST_NAME']);

function _updated() {
	global $ENV,$config;
	if(!empty($config['menu_updated_format']))
		$format=$config['menu_updated_format'];
	else
		$format='D d F Y H:i T';
	echo "<div class=\"updated\">Last modified on ";
	echo date($format,filemtime("$ENV[DOCUMENT_ROOT]$ENV[REQUEST_NAME]"));
	echo " </div>";
}

function _structure($pagetitle) {
	global $ENV,$title,$config;
	echo "<span class=\"structure\">";
	reset($title);
	while (list($p,$t)=each($title)) {
		if ($p!=$ENV['REQUEST_NAME']) {
			echo $config['structure_delimiter']; _link($p,$t);
		} else {
			echo "$config[structure_delimiter]<span class=\"structactive\">$pagetitle</span>";
		}
		echo '&nbsp;';
	}
	echo "</span>\n";
}

function _menu() {
	echo "\n<!-- menu start -->\n";
	echo "<span class=\"menu\">\n";
	_printMenu("/");
	echo "</span>";
	echo "\n<!-- menu end -->\n";
}

function _printMenu($path) {
	global $config, $ENV;

	$MENUFILE=".menu";
	$REQUEST=$ENV["REQUEST_NAME"];
	$temp=explode('/',$path);
	$i=count($temp);

#	$p="";
#	for ($j=1;$j<$i;$j++) $p.="/$temp[$j]";
	$fp="$config[path]$path";

//	echo "<b>path=$fp/$MENUFILE|p=$p</b><br>";
	if (is_dir("$ENV[DOCUMENT_ROOT]$fp") and
		is_readable("$ENV[DOCUMENT_ROOT]$fp/$MENUFILE")) {
		$fp=fopen("$ENV[DOCUMENT_ROOT]$fp/$MENUFILE","r");
		while ($data=fgetcsv($fp,1000)) {
			if(empty($data)) {
				echo "<br>\n";
				continue;
			} elseif(eregi("^#",$data[0])) {
				continue;
			}
			for ($j=1;$j<$i-2;$j++) echo $config['menu_delimiter'];
			for (;$j<$i-1;$j++) echo $config['menu_end_delimiter'];
			if (empty($data[1])) $data[1]="";
			if (empty($data[2])) $data[2]="";
			$link=$data[0];
			$file=substr($data[0],0,strcspn($data[0],"?#"));
			$title=$data[1];
			$descr=$data[2];
			if (!empty($link) and !empty($descr)) _setDescr($link,$descr);
			if (!empty($link) and $title=="") $title=_readTitle("$ENV[DOCUMENT_ROOT]$file","");
			if (empty($link)) {
				if (empty($title)) echo "<br>\n";
				else echo "<span class=\"nolink\">$title</span><br>\n";
			} elseif (is_dir("$ENV[DOCUMENT_ROOT]$link") and
					is_readable("$ENV[DOCUMENT_ROOT]$link/$MENUFILE")){
				if ($link==$ENV["REQUEST_NAME"]) {
//					echo "<span class=\"activesub\" title=\"$descr\">$title</span><br>\n";
					_link('#',$title,"activesub"); echo "<br>\n";
					_printMenu($link);
				} elseif (eregi("^$file",$ENV["REQUEST_NAME"])) {
					_link($file,$title,"relatedsub"); echo "<br>\n";
					_printMenu($file);
				} elseif ($config['menu_expand_all']) {
					_link($file,$title,"sub"); echo "<br>\n";
					if (!ereg($config['hidden_paths'],$link))
						_printMenu($file);
				} else {
					_link($link,$title,"sub"); echo '<br>';
				}
			} elseif (is_readable("$ENV[DOCUMENT_ROOT]$file") or
						is_dir("$ENV[DOCUMENT_ROOT]$file") or
  						eregi("^javascript:",$link)) {
				if ($link==$ENV["REQUEST_NAME"]) {
					echo "<span class=\"active\" title=\"$descr\">$title</span><br>";
				} else {
					_link($link,$title); echo "<br>";
				}
			} elseif (eregi("^ftp:",$link) or
						eregi("^file:",$link) or
						eregi("^http:",$link) or
						eregi("^https:",$link)) {
					_link($link,"$title..."); echo "<br>";
			} else {
					echo "<textspan class=\"missing\" title=\"$descr\">$title</textspan><br>";
			}
			echo "\n";
		}
		fclose ($fp);
	}
}
?>
