<?
/*
	This file is a shared library and contains code that is used
	by more than one website. Everything that is specific to a
	certain website must go in local.inc.

	If you really need to change functions in this file, please
	add them to the end of this file.
*/

function _link(/* link,name,class */) {
	global $descr;
	$numargs=func_num_args();
	$link=func_get_arg(0);
	$desc="";
	_readDescr($link);
	if (!empty($descr[$link]))
			$desc=" title=\"$descr[$link]\"";
	if ($numargs==1)
		echo "<a href=\"$link\"$desc>$link</a>";
	elseif ($numargs==2)
		echo "<a href=\"$link\"$desc>".func_get_arg(1)."</a>";
	else
		echo "<a href=\"$link\"$desc class=\"".func_get_arg(2)."\">".func_get_arg(1)."</a>";
}

function _title($title) {
	echo "<div class=\"title\"><a name=\""._createName($title)."\">$title</a></div>\n";
}

function _header() {
	global $config, $ENV;
	header("Cache-Control: no-cache; must-revalidate");
	header("Content-Type: text/html; charset=$config[charset]");
//	header("Expires: ".date("D, d M Y H:i:s",time())." GMT");
	header("Expires: 0");
	header("Last-Modified: ".gmdate('D, d M Y H:i:s',filemtime("$ENV[DOCUMENT_ROOT]$ENV[REQUEST_NAME]"))." GMT");
	header("Pragma: no-cache, no-store");
}

/* Generate Meta-headers */
function _generateMeta($pagetitle) {
	global $meta, $config, $title;

    if (empty($meta["title"])) $meta["title"]=$pagetitle;
    if ($meta["description"]=="") $meta["description"]=$pagetitle;

    end($title); while(prev($title)) $meta["keywords"].=current($title).", ";
    if (!empty($config["keywords"])) $meta["keywords"].=$config["keywords"];

    $meta['keywords']=$meta['title'].', '.$meta['keywords'];

	//  $meta["date"]=date("D, d M Y H:i:s")." GMT";
}

/* Place Meta-headers */
function _meta() {
	global $meta;

	echo "\n<!-- meta start -->\n";
	reset($meta);   
	while (list($name,$content)=each($meta))
		echo "<meta name=\"".ucfirst($name)."\" content=\"$content\">\n";
	echo "<!-- meta end -->\n";
}
?>
